
const RoleServices = require('../Services/Role.services');
const UserServices = require('../Services/User.services');
const constpermission = require('../Constants/permission');

const fs = require('fs');

// module.exports = async (req, res, next, permission) => {
//     try {

//         const user = req.local.user;

//         var constPermission = constpermission;
//             //    console.log( constPermission[permission.name][permissionResult.value])
//         const role = user.role;
//         // console.log(role)
//         const permissionResults = await RoleServices.findByRole({ name: { $in: role } });
//         // console.log("permission result= ",permissionResult);
//         if (!permissionResults.status) return res.status(401).send({ ...permissionResults });

//         // console.log(permissionResults)
//         var permissionResult = {};

//         var access = false;
//         // await Promise.all(permissionResults.roles.map(async (data) => {

//         permissionResults.roles.forEach((data) => {

//             constPermission[permission.name][permission.value].value = data.permissions[permission.name][permission.value].value || constPermission[permission.name][permission.value].value

//             permissionResult = data;
//             return false;

//         })
//         // console.log(permissionResult);
//         if (!permissionResult.permissions[permission.name]['access'].value || user.permissions[permission.name]['access'].value) {

//             if (permissionResult.permissions[permission.name][permission.value].value || user.permissions[permission.name][permission.value].value) {
//                 // console.log("allow access");
//                 // console.log(user.permissions[permission.name]);
//                 access = true;
//             }
//             else {
//                 // console.log("deny access");
//                 access = false;
//                 // return res.status(403).send({ status: false, error: 'Unauthorized User!' });
//             }
//         }
//         else {
//             // console.log("allowAccess");
//             // next();
//             access = true;
//         }

//         if (access) {
//             next()
//         }
//         else {
//             return res.status(403).send({ status: false, error: 'Unauthorized User!' });

//         }

//         // const value = permissionResult.roles.permissions[permission.name][permission.value].value;


//     }
//     catch (e) {
//         console.log(e);
//         return res.status(500).send({ status: false, error: 'Internal Server Error!' });
//     }
// };

module.exports = async (req, res, next, routePermissionObj) => {
    try {

        // console.log( "========== is permission middleware ================= ",req);
        const user = req.local.user;
        const routePermission = routePermissionObj.name;
        const routeSubPermission = routePermissionObj.value;
       
        if (!user) { return res.status(403).send({ status: false, noPermission: true, error: `Unauthorized User! Don't have ${capitalize(routeSubPermission)} ${capitalize(routePermission)} Permission ` }) }
        const userPermission = user.toJSON().permission;

        const permissionJsonRead = fs.readFileSync('./Utils/permissions.json');
        const permissionJson = JSON.parse(permissionJsonRead);

        var permissionVal = 0;
        var access = false;
        if ("permission" in user) {
            await Promise.all(
                permissionJson.map(async (perJson) => {
                    if (perJson.title === routePermission) {
                        await Promise.all(
                            perJson.permission.map(async (perSubJson) => {

                                if (perSubJson.label === routeSubPermission) {
                                    permissionVal = perSubJson.value;
                                }
                            })
                        )
                    }
                })
            )

            const binaryRes = permissionVal & "0b" + userPermission[routePermission];
            // console.log(userPermission[routePermission], "========= binaryRes");
            if (binaryRes == permissionVal) {
                access = true;
            }
        }

        if (access) {
            next()
        }
        else {
            return res.status(403).send({ status: false, noPermission: true, error: `Unauthorized User! Don't have ${capitalize(routeSubPermission)} ${capitalize(routePermission)} Permission ` });
        }

    }
    catch (e) {
        console.log("🚀 ~ file: isPermission.js:121 ~ module.exports= ~ e:", e)
        return res.status(500).send({ status: false, error: 'Internal Server Error!' });
    }
};
capitalize = (s) => {
    if (typeof s !== 'string') return '';
    return s.charAt(0).toUpperCase() + s.substring(1).toLowerCase()
}