#!/bin/bash

SOURCE_HOST="192.168.1.99"
REMOTE_DB="realvalue"
PORT=27017
DATE=$(date +\"%Y%m%d\")

DEST_HOST="192.168.1.104"
LOCAL_DB="realvalue_beta_1406"

USER="remote-user-name"
PASS="passwordForRemoteUser"

## DUMP REMOTE DATABASE
echo "Dumping '$SOURCE_HOST:$PORT/$REMOTE_DB'..."
mongodump --host $SOURCE_HOST:$PORT --db $REMOTE_DB #-u $USER -p $PASS

#echo "Restoring to '$LOCAL_DB'..."
mongorestore --host $DEST_HOST:$PORT --db $LOCAL_DB --drop dump/$REMOTE_DB
# zip -r dump_$DATE.zip ./dump

cp ./dump /home/public_html/CDN/sec_db_bk/
## REMOVE DUMP FILES
# echo "Removing dump files..."
rm -r dump #dump_$DATE.zip

echo "Finished."