const mongoose = require('mongoose');

const Schema = mongoose.Schema;

const cdnSuccessSchema = Schema({
    sourcePath: {
        type: String
    },
    date: {
        type: String,
    },
    status: {
        type: Boolean
    },
    destinationPath: {
        type: String
    },
    error: {
        type: String
    }

}, { timestamps: true });


module.exports = mongoose.model('CdnSuccess', cdnSuccessSchema);