const mongoose = require('mongoose');
const { userSchema } = require('./CommonSchema');

const Schema = mongoose.Schema;

const notificationSchema = Schema({
    user: userSchema,
    pushTokens: [],
    body: {},
    data: {},
    response: {},
    read: { type: Boolean, status: false },
    isDeleted: { type: Boolean, status: false }
}, { timestamps: true });

module.exports = mongoose.model('Notification', notificationSchema);