const express = require("express");
const router = express.Router();
const uploadController = require("../Controllers/BulkImport.controller");
const uploadFile = require("../Middleware/uploadFile");
const isAuth = require('../Middleware/isAuth');

// Upload Excel and insert data
router.post(
    "/bulk-import/:modelName",
    isAuth, // Authentication middleware
    uploadFile.importExcel, uploadController.uploadExcelFile
);

module.exports = router;